function [f,ng]=evalf(x,type)
%The function evaluate the function of the function at x.
%Input:
%   x --- the point to be evaluated at.
%type --- 1 only f
%         2 only negative gradient
%         3 both f and ng.
%Output:
%   f --- the value of f at point x.

%[f,ng]=evalf8(x,type);

global mask rimg m1 m2 m3 m4;

%f=sum(sqrt(x.^2+0.0001));
rimg(mask)=x;

[n,m]=size(mask);
%Use the reflection boundary condition.
% dxf=diff([rimg(:,1) rimg],1,2);  %Forward diffrence of the image in x-direction.
% dxb=-diff([rimg rimg(:,m)],1,2);  %Backward diffrence of the image in x-direction.
% dyf=diff([rimg(1,:);rimg],1,1);  %Forward diffrence of the image in y-direction.
% dyb=-diff([rimg;rimg(n,:)],1,1);  %Backward diffrence of the image in y-direction.
temp=[rimg(:,1) rimg(:,1:m-1)];dxf=rimg(mask)-temp(mask);
temp=[rimg(:,2:m) rimg(:,m)];dxb=temp(mask)-rimg(mask);
temp=[rimg(1,:);rimg(1:n-1,:)];dyf=rimg(mask)-temp(mask);
temp=[rimg(2:n,:);rimg(n,:)];dyb=temp(mask)-rimg(mask);

if nargin==1
    type=3;
end

if (type==1);
    pdxf=phi(dxf);
    pdxb=phi(dxb);
    pdyf=phi(dyf);
    pdyb=phi(dyb);
    f=sum(sum(m1(mask).*pdxf))+sum(sum(m2(mask).*pdxb))...
        +sum(sum(m3(mask).*pdyf))+sum(sum(m4(mask).*pdyb));
    ng=0;
    return
end

if (type==2)
%    pdxf=dxf./pdxf;
%    pdxb=dxb./pdxb;
%    pdyf=dyf./pdyf;
%    pdyb=dyb./pdyb;
    pdxf=zeros(n,m);pdxf(mask)=m1(mask).*phiD(dxf);
    pdxb=zeros(n,m);pdxb(mask)=m2(mask).*phiD(dxb);
    pdyf=zeros(n,m);pdyf(mask)=m3(mask).*phiD(dyf);
    pdyb=zeros(n,m);pdyb(mask)=m4(mask).*phiD(dyb);
%    pdxf=phiD(dxf);
%    pdxb=phiD(dxb);
%    pdyf=phiD(dyf);
%    pdyb=phiD(dyb);
    temp=[pdxf(:,2:m) zeros(n,1)];ngrad=pdxf(mask)-temp(mask);
    temp=[zeros(n,1) pdxb(:,1:m-1)];ngrad=ngrad+temp(mask)-pdxb(mask);
    temp=[pdyf(2:n,:);zeros(1,m)];ngrad=ngrad+pdyf(mask)-temp(mask);
    temp=[zeros(1,m);pdyb(1:n-1,:)];ngrad=ngrad+temp(mask)-pdyb(mask);
%     ngrad=-(-diff([pdxf.*n1 zeros(n,1)],1,2));
%     ngrad=ngrad-(diff([zeros(n,1) pdxb.*n2],1,2));
%     ngrad=ngrad-(-diff([pdyf.*n3;zeros(1,m)],1,1));
%     ngrad=ngrad-(diff([zeros(1,m);pdyb.*n4],1,1));
%    ngrad=-(pdxf.*m1.*mask-[pdxf(:,2:n) pdxf(:,n)].*[mask(:,2:n) mask(:,n)]);
%    ngrad=ngrad-(pdxb.*m2.*mask-[pdxb(:,1) pdxb(:,1:n-1)].*[mask(:,1) mask(:,1:n-1)]);
%    ngrad=ngrad-(pdyf.*m3.*mask-[pdyf(2:n,:);pdyf(n,:)].*[mask(2:n,:);mask(n,:)]);
%    ngrad=ngrad-(pdyb.*m4.*mask-[pdyb(1,:);pdyb(1:n-1,:)].*[mask(1,:);mask(1:n-1,:)]);
      
      
    ng=-ngrad;
    f=0;
    return
end

if type==3
    pdxf=phi(dxf);
    pdxb=phi(dxb);
    pdyf=phi(dyf);
    pdyb=phi(dyb);
    f=sum(sum(m1(mask).*pdxf))+sum(sum(m2(mask).*pdxb))...
        +sum(sum(m3(mask).*pdyf))+sum(sum(m4(mask).*pdyb));
    pdxf=zeros(n,m);pdxf(mask)=m1(mask).*phiD(dxf);
    pdxb=zeros(n,m);pdxb(mask)=m2(mask).*phiD(dxb);
    pdyf=zeros(n,m);pdyf(mask)=m3(mask).*phiD(dyf);
    pdyb=zeros(n,m);pdyb(mask)=m4(mask).*phiD(dyb);
    temp=[pdxf(:,2:m) zeros(n,1)];ngrad=pdxf(mask)-temp(mask);
    temp=[zeros(n,1) pdxb(:,1:m-1)];ngrad=ngrad+temp(mask)-pdxb(mask);
    temp=[pdyf(2:n,:);zeros(1,m)];ngrad=ngrad+pdyf(mask)-temp(mask);
    temp=[zeros(1,m);pdyb(1:n-1,:)];ngrad=ngrad+temp(mask)-pdyb(mask);
    ng=-ngrad;
end

if nargin==1
    ng=-ng;
end